/**
 * DREAM
 * Copyright (C) 2003-2004 INRIA Rhone-Alpes
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Contact : dream@objectweb.org
 *
 * Initial developer(s): Vivien Quema
 * Contributor(s):
 */

package org.objectweb.dream.pushwithreturn;

import java.util.HashMap;
import java.util.Iterator;


import org.objectweb.dream.dreamannotation.DreamComponent;

/**
 * TODO
 */
@DreamComponent(controllerDesc = "dreamPrimitive")
public class WaitingKeys  implements WaitingKeysItf
{
  /** An hash map containing waiting keys. */
  HashMap<Key, WaitingKey> waitingKeysMap = new HashMap<Key, WaitingKey>();

  // ---------------------------------------------------------------------------
  // Implementation of the WaitingKeysItf interface.
  // ---------------------------------------------------------------------------

  /**
   * @see WaitingKeysItf#removeWaitingKey(Key)
   */
  public WaitingKey removeWaitingKey(Key key)
  {
    return waitingKeysMap.remove(key);
  }

  /**
   * @see WaitingKeysItf#removeWaitingKeys(Key)
   */
  public Iterator removeWaitingKeys(Key key)
  {
    Iterator iter = waitingKeysMap.values().iterator();
    waitingKeysMap = new HashMap<Key, WaitingKey>();
    return iter;
  }

  /**
   * @see WaitingKeysItf#createWaitingKey(Key)
   */
  public WaitingKey createWaitingKey(Key key)
  {
    WaitingKey waitingKey = new WaitingKey();
    waitingKey.setKey(key);
    waitingKeysMap.put(key, waitingKey);
    return waitingKey;
  }
}
